-- ========================================================================== --
-- 										 EskaQuestTracker                                       --
-- @Author   : Skamer <https://mods.curse.com/members/DevSkamer>              --
-- @Website  : https://wow.curseforge.com/projects/eska-quest-tracker         --
-- ========================================================================== --
Scorpio             "EskaQuestTracker.Classes.WorldQuestBlock"           "1.0.0"
-- ========================================================================== --
namespace "EQT"
-- ========================================================================== --
class "WorldQuestBlock" inherit "Block"
  -- ======================================================================== --
  -- Methods
  -- ======================================================================== --
  __Arguments__ { WorldQuest }
  function AddWorldQuest(self, worldQuest)
    if not self.worldQuests:Contains(worldQuest) then
      self.worldQuests:Insert(worldQuest)
      worldQuest:SetParent(self.frame)
    end
  end

  __Arguments__ { Number }
  function RemoveWorldQuest(self, worldQuestID)
    local worldQuest = self:GetWorldQuest(worldQuestID)
    if worldQuest then
      self:RemoveWorldQuest(worldQuest)
    end
  end


  __Arguments__ { WorldQuest }
  function RemoveWorldQuest(self, worldQuest)
    self.worldQuests:Remove(worldQuest)
    worldQuest.isReusable = true
  end

  __Arguments__ { Number }
  function GetWorldQuest(self, worldQuestID)
    for _, worldQuest in self.worldQuests:GetIterator() do
      if worldQuest.id == worldQuestID then
        return worldQuest
      end
    end
  end

  __Arguments__()
  function Draw(self)
    local previousFrame
    local height = 0

    for index, worldQuest in self.worldQuests:GetIterator() do
      worldQuest:ClearAllPoints()
      worldQuest:Show()
      worldQuest:Draw()

      if index == 1 then
        worldQuest.frame:SetPoint("TOPLEFT", 0, -35)
        worldQuest.frame:SetPoint("TOPRIGHT", 20, -35)
      else
        worldQuest.frame:SetPoint("TOPLEFT", previousFrame, "BOTTOMLEFT", 0, -5)
        worldQuest.frame:SetPoint("TOPRIGHT", previousFrame, "BOTTOMRIGHT")
      end

      height = height + worldQuest.height
      previousFrame = worldQuest.frame
    end

    self.height = self.baseHeight + height
  end


  function WorldQuestBlock(self)
    Super(self, "WorldQuests", 15)
    self.text = "World Quests"

    self.worldQuests = ObjectArray(WorldQuest)
  end


endclass "WorldQuestBlock"
